package com.fjhx.customer.handle;


import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fjhx.customer.entity.xiaoman.po.XiaomanCustomer;
import com.fjhx.customer.entity.xiaoman.vo.CustomerListApiVo;
import com.fjhx.customer.service.xiaoman.XiaomanCustomerService;
import com.fjhx.customer.service.xiaoman.impl.XiaomanCustomerServiceImpl;
import com.ruoyi.common.utils.spring.SpringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


import javax.swing.*;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class HandleXiaomanData {



    public static void main(String[] args) {
        String filePath = "D:\\java_conding\\erhong\\hx-customer\\src\\main\\java\\com\\fjhx\\customer\\handle\\aaa.json";
        String jsonData = "";

        try (BufferedReader br = new BufferedReader(new FileReader(filePath))) {
            String line;
            while ((line = br.readLine()) != null) {
                jsonData += line;
            }

            handleAllCustomer(jsonData);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static CustomerListApiVo handleAllCustomer(String res){
        CustomerListApiVo customerListApiVo = handleList(res, new TypeReference<R<CustomerListApiVo>>() { });

        XiaomanCustomerServiceImpl xiaomanCustomerService = SpringUtils.getBean(XiaomanCustomerServiceImpl.class);
        if (!customerListApiVo.getList().isEmpty()){
            List<XiaomanCustomer> xiaomanCustomerList = new ArrayList<>(customerListApiVo.getList());
            xiaomanCustomerService.saveOrUpdateBatch(xiaomanCustomerList);
        }

        return customerListApiVo;
    }



    public static <T> T handleList(String res, TypeReference<R<T>> typeReference) {
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            R<T> result = objectMapper.readValue(res, typeReference);
            if (result.isOk()) {
                return result.getData();
            }
            return null;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

}
