package com.fjhx.customer.service.xiaoman.impl;

import com.fjhx.customer.entity.xiaoman.po.XiaomanCustomer;
import com.fjhx.customer.mapper.xiaoman.XiaomanCustomerMapper;
import com.fjhx.customer.service.xiaoman.XiaomanCustomerService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.customer.entity.xiaoman.vo.XiaomanCustomerVo;
import com.fjhx.customer.entity.xiaoman.dto.XiaomanCustomerSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.customer.entity.xiaoman.dto.XiaomanCustomerDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.List;

import static com.ruoyi.common.utils.wrapper.IWrapper.getWrapper;

/**
 * <p>
 * 小满客户表 服务实现类
 * </p>
 *
 * @author lqh
 * @since 2024-04-06
 */
@Service
public class XiaomanCustomerServiceImpl extends ServiceImpl<XiaomanCustomerMapper, XiaomanCustomer> implements XiaomanCustomerService {

    @Override
    public List<XiaomanCustomerVo> getList(XiaomanCustomerSelectDto dto) {
        IWrapper<XiaomanCustomer> wrapper = getWrapper();
        wrapper.orderByDesc("xc", XiaomanCustomer::getCompanyId);
        List<XiaomanCustomerVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<XiaomanCustomerVo> getPage(XiaomanCustomerSelectDto dto) {
        IWrapper<XiaomanCustomer> wrapper = getWrapper();
        wrapper.orderByDesc("xc", XiaomanCustomer::getCompanyId);
        Page<XiaomanCustomerVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public XiaomanCustomerVo detail(Long id) {
        XiaomanCustomer XiaomanCustomer = this.getById(id);
        XiaomanCustomerVo result = BeanUtil.toBean(XiaomanCustomer, XiaomanCustomerVo.class);
        return result;
    }

    @Override
    public void add(XiaomanCustomerDto xiaomanCustomerDto) {
        this.save(xiaomanCustomerDto);
    }

    @Override
    public void edit(XiaomanCustomerDto xiaomanCustomerDto) {
        this.updateById(xiaomanCustomerDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
